'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /* global fetch */
/* eslint class-methods-use-this: ["error", { "exceptMethods": ["request"] }] */

var _config = require('./config');

var _repositories = require('./repositories');

var _repositories2 = _interopRequireDefault(_repositories);

var _commits = require('./commits');

var _commits2 = _interopRequireDefault(_commits);

var _contributors = require('./contributors');

var _contributors2 = _interopRequireDefault(_contributors);

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GithubApiWrapper = function () {
  function GithubApiWrapper(options) {
    _classCallCheck(this, GithubApiWrapper);

    this.apiUrl = options.apiUrl || _config.API_URL;
    this.userName = options.userName || _config.USER_NAME;

    this.repositories = _repositories2.default.bind(this)();
    this.commits = _commits2.default.bind(this)();
    this.contributors = _contributors2.default.bind(this)();
  }

  _createClass(GithubApiWrapper, [{
    key: 'request',
    value: function request(url) {
      return fetch(url).then(_utils2.default);
    }
  }]);

  return GithubApiWrapper;
}();

exports.default = GithubApiWrapper;